//====================================================================================================
// About.cpp -   
//====================================================================================================

#include "StdAfx.h"
#include "Common.h"  //      
#include "About.h"

//====================================================================================================
//  
//====================================================================================================

HBITMAP g_hAboutBitmap = NULL;  //  
HBITMAP g_hLogoBitmap = NULL;  //    

//====================================================================================================
//       ()   
//====================================================================================================
enum {
  g_eWinTitle = 0,  //  
  g_eWinWidth1000,  //    (     )
  g_eWinHeight1000,  //    (     )
  //g_eWinLeft1000, //     (     )
  //g_eWinTop1000, //     (     )
  g_eCommand,  //        
  //g_eWinTextMax, //      
  g_eWinText,  //    
  g_eMax  //  ()    
};  // enum

//====================================================================================================
//     CAbout
//====================================================================================================

//       ()  
wstring CAbout::m_wsaComments[g_eMax + 1] = {
  L";   :",  // g_eWinTitle
  L";    (     ):",  // g_eWinWidth1000
  L";    (     ):",  // g_eWinHeight1000
  //L";     (     ):",  // g_eWinLeft1000
  //L";     (     ):",  // g_eWinTop1000
  L";        :",  // g_eCommand
  //L";      :",  // g_eWinTextMax
  L";    :",  // g_eWinText
  L""  // eMax -  ()    
};  // wstring CAbout::m_wsaComments[g_eMax + 1]

//   ,  ,    ()  
wstring CAbout::m_wsaFileVars[g_eMax + 1] = {
  L" ",  // g_eWinTitle
  L"450",  // g_eWinWidth1000
  L"485",  // g_eWinHeight1000
  //L"0",  // g_eWinLeft1000
  //L"25",  // g_eWinTop1000
  L"&9-/&9- \tCtrl+A",  // g_eCommand
  //L"1",  // g_eWinTextMax
  L":\nAppPlugins, v. 0.01.\n\n\" \".\n\n   \n ,\n  .\n\nCopyright (c), EE-2021...",  // g_eWinText01
  L""  // g_eMax -     
};  // wstring CAbout::m_wsaFileVars[g_eMax + 1]

//====================================================================================================
//    CAbout
//====================================================================================================

LPCWSTR CAbout::m_wsPlugClassName = L"AboutWindow";  //     
LPCWSTR CAbout::m_wsPlugIniFile = L"Plugins\\Res\\About.ini";  //  ini- 
LPCWSTR CAbout::m_wsPlugIcon = L"Plugins\\Res\\About.ico";  //   (   )
LPCWSTR CAbout::m_wsAboutBmp = L"Plugins\\Res\\About.bmp";  //   bmp-    
LPCWSTR CAbout::m_wsLogoBmp = L"Plugins\\Res\\Logo.bmp";  //   bmp-   
LPCWSTR CAbout::m_wFontName = L"Arial";  //      
const int CAbout::m_nFontHeight = 22;  //      
const COLORREF CAbout::m_nTextColor = RGB(0, 0, 96);  //     - -

//   
APPMEMVARS CAbout::m_struAppVars = {0};  //  
CCommonInterface *CAbout::m_pIMain = NULL;  //       

//    
int CAbout::m_nWinWidth = 0;  //  
int CAbout::m_nWinHeight = 0;  //  

//  
BOOL CAbout::m_bIsRegistration = FALSE;  //    
HWND CAbout::m_hAbout = NULL;  //     
int CAbout::m_nWin = 0;  //     (,   )

//  
int CAbout::m_nAboutWidth = 0;  //   About.bmp
int CAbout::m_nAboutHeight = 0;  //   About.bmp
BOOL CAbout::m_bIsAboutBmp = FALSE;  //    About.bmp

// 
int CAbout::m_nLogoWidth = 0;  //   Logo.bmp
int CAbout::m_nLogoHeight = 0;  //   Logo.bmp
BOOL CAbout::m_bIsLogoBmp = FALSE;  //    Logo.bmp

//  
HFONT CAbout::m_hFont;  //  

//====================================================================================================
// CAbout::InitParams() -   
//====================================================================================================
void CAbout::InitParams(APPMEMVARS &struAppVars, CCommonInterface *pIIni) {
  //         
  m_pIMain = pIIni;

  //     ini-    m_wsaFileVars
  m_pIMain->ReadIniFile(m_wsPlugIniFile, m_wsaFileVars, g_eMax + 1);

  //    
  m_struAppVars = struAppVars;  //   (  )

  //     
  m_hFont = CreateFont(
    m_nFontHeight, 0, 0, 0, 500,
    FALSE, FALSE, FALSE,
    DEFAULT_CHARSET,
    OUT_DEFAULT_PRECIS,
    CLIP_DEFAULT_PRECIS, 
		PROOF_QUALITY,
    VARIABLE_PITCH,
    m_wFontName
  );

  //      
  m_pIMain->MakeFolders(m_wsPlugIniFile);
}  // CAbout::InitParams()

//====================================================================================================
// CAbout::RegisterMDIChild() -   MDI  
//====================================================================================================
BOOL CAbout::RegisterMDIChild() {
  HINSTANCE hInstance = m_struAppVars.hInstance;
  HICON hIcon = (HICON) LoadImage(hInstance, m_wsPlugIcon, IMAGE_ICON, 0, 0, LR_LOADFROMFILE);
  HCURSOR hCursor = (HCURSOR) LoadImage(hInstance, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_SHARED);

  WNDCLASSEX WCX = {0};
  
  WCX.cbSize = sizeof(WNDCLASSEX);
  WCX.style = CS_HREDRAW | CS_VREDRAW; 
  WCX.lpfnWndProc = MDIPluginWndProc; 
  WCX.cbWndExtra = sizeof(HWND); 
  WCX.hInstance = hInstance; 
  WCX.hIcon = hIcon; 
  WCX.hCursor = hCursor; 
  WCX.lpszClassName = m_wsPlugClassName;
  WCX.hIconSm = hIcon;
  WCX.hbrBackground = NULL;  // CreateSolidBrush(RGB(222, 164, 222)); 
  WCX.lpszMenuName = NULL;

  //       Windows
  if(!RegisterClassEx(&WCX)) {
    MessageBox(NULL, L"About: RegisterMDIPlug() is wrong!", L"", MB_OK);
    return FALSE;
  }  // if(!RegisterClassEx(&WCX))

  m_bIsRegistration = TRUE;  //    

  return TRUE;
}  // CAbout::RegisterMDIChild()

//====================================================================================================
// CAbout::CreateMDIChildWnd() -   MDI  
//====================================================================================================
BOOL CAbout::CreateMDIChildWnd() {
  //f(k >= m_nWinMax) return 0;

  static RECT R = {0};
  GetClientRect(m_struAppVars.hMDIClient, &R);

  //           (    )
  m_nWinWidth = m_pIMain->CalcProportion(stoi(m_wsaFileVars[g_eWinWidth1000]), R.right, 1000);  //  
  m_nWinHeight = m_pIMain->CalcProportion(stoi(m_wsaFileVars[g_eWinHeight1000]), R.bottom, 1000);  //  

  static int nX = 0;
  static int nY = 0;

  if(m_nWin == 0) {  //    
    nX = (R.right - m_nWinWidth) / 2;  //  
    nY = (R.bottom - m_nWinHeight)/2;  //  
  } else {
    return FALSE;
  }  // if(m_nWin == 0)

  m_hAbout = CreateWindowEx(
    WS_EX_MDICHILD,
    m_wsPlugClassName,
    m_wsaFileVars[g_eWinTitle].c_str(),  // Windows Title
    WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,  // | WS_CHILD
    nX,  // Left
    nY,  // Top
    m_nWinWidth,  // Width
    m_nWinHeight,  // Height
    m_struAppVars.hMDIClient,  // Parent
    NULL,  // Menu
    m_struAppVars.hInstance,  // Instance
    NULL  // User defined info
  );

  if(!m_hAbout) {
    //MessageBox(NULL, L"About: m_hAbout == NULL!", L"", MB_OK);
    return FALSE;
  }  // if(!m_hAbout)

  //m_hWinKMap[m_hAbout] = m_nWin;  //        
  //m_hWindows[m_nWin] = m_hAbout;  //     
  ++m_nWin;

  return TRUE;
}  // CAbout::CreateMDIChildWnd()

//====================================================================================================
// CAbout::IsRegistration() -      
//====================================================================================================
BOOL CAbout::IsRegistration() {
  return m_bIsRegistration;
}  // CAbout::GetHPlugWnd()

//====================================================================================================
// CAbout::GetHChildWnd() -      
//====================================================================================================
HWND CAbout::GetHChildWnd() {
  return m_hAbout;
}  // CAbout::GetHChildWnd()

//====================================================================================================
// CAbout::GetMenuCommand() -         
//====================================================================================================
wstring &CAbout::GetMenuCommand() {
  static wstring wsCommand = m_wsaFileVars[g_eCommand];
  return wsCommand;
}  // CAbout::GetMenuCommand()

//====================================================================================================
// CAbout::WriteCenteredText() -       
//====================================================================================================
void CAbout::WriteCenteredText(HDC hDC, RECT &R) {
  //     
  SetBkMode(hDC, TRANSPARENT);
        
  //     
  SetTextColor(hDC, m_nTextColor);
        
  HFONT hOldFont = (HFONT) SelectObject(hDC, m_hFont);
  wstring wsText = L"";

  wsText = m_wsaFileVars[g_eWinText];  //    
  
  //        
  int n = 1;  //      
  for(int i = 0; i < (int) wsText.size(); ++i) {
    if(wsText[i] == '\n') ++n;
  }  // for(int i = 0; i < wsText.size(); ++i)

  if(n*m_nFontHeight < R.bottom) R.top = (R.bottom - n*m_nFontHeight)/2;  //  

  DrawText(hDC, (LPWSTR) wsText.c_str(), (int) wsText.size(), &R, DT_CENTER);
        
  SelectObject(hDC, hOldFont);
}  // CAbout::WriteCenteredText()

//====================================================================================================
// CAbout::GetPluginWindowPos() -       
//====================================================================================================
void CAbout::GetPluginWindowPos(HWND hWnd) {
  RECT Rect = {0};  //  

  //    
  GetWindowRect(hWnd, &Rect);
  int nPlugWidth = Rect.right - Rect.left;  //   k
  int nPlugHeight = Rect.bottom - Rect.top;  //   k

  //      
  GetWindowRect(m_struAppVars.hMDIClient, &Rect);
  int nParentWidth = Rect.right - Rect.left;  //     
  int nParentHeight = Rect.bottom - Rect.top;  //     

  //    ( )   (    )
  int nWinWidth1000 = MulDiv(1000, nPlugWidth, nParentWidth);  //  
  int nWinHeight1000 = MulDiv(1000, nPlugHeight, nParentHeight);  //  

  //     g_wsaFileVars
  m_wsaFileVars[g_eWinWidth1000] = WOSS(nWinWidth1000);
  m_wsaFileVars[g_eWinHeight1000] = WOSS(nWinHeight1000);
}  // CAbout::GetPluginWindowPos()

//====================================================================================================
// void CAbout::DoCreate() -   WM_CREATE
//====================================================================================================
void CAbout::DoCreate(HWND hWnd) {
  //----------------------------------------------------------------------------------------------------
  // About.bmp -  
  //----------------------------------------------------------------------------------------------------

  //  g_hAboutBitmap   ,  
  if(!g_hAboutBitmap) {
    //   m_wsAboutBmp  ,    
    if(m_wsAboutBmp) {      
      //   
      g_hAboutBitmap = (HBITMAP) LoadImage(m_struAppVars.hInstance, m_wsAboutBmp, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
      
      //  
      if(g_hAboutBitmap) {
        //   
        BITMAP BM = {0};
        GetObject(g_hAboutBitmap, sizeof(BITMAP), (LPVOID) &BM);

        m_nAboutWidth = BM.bmWidth;  //   About.bmp
        m_nAboutHeight = BM.bmHeight;  //   About.bmp
        m_bIsAboutBmp = TRUE;  //    About.bmp
      } else {  // g_hAboutBitmap == FALSE
        wstring wsText = L"About:    :\n" + wstring(m_wsAboutBmp);
        MessageBox(NULL, wsText.c_str(), L"", MB_OK);
      }  // if(g_hAboutBitmap)
    } else {  // m_wsAboutBmp == NULL
      MessageBox(NULL, L"About:     : \"About.bmp\"!\n", L"", MB_OK);
    }  // if(!m_wsAboutBmp)
  }  // if(!g_hAboutBitmap)

  //----------------------------------------------------------------------------------------------------
  // Logo.bmp -    
  //----------------------------------------------------------------------------------------------------

  //  g_hLogoBitmap   ,  
  if(!g_hLogoBitmap) {
    //   m_wsLogoBmp  ,    
    if(m_wsLogoBmp) {      
      //   
      g_hLogoBitmap = (HBITMAP) LoadImage(m_struAppVars.hInstance, m_wsLogoBmp, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
      
      //  
      if(g_hLogoBitmap) {
        //   
        BITMAP BM = {0};
        GetObject(g_hLogoBitmap, sizeof(BITMAP), (LPVOID) &BM);

        m_nLogoWidth = BM.bmWidth;  //   Logo.bmp
        m_nLogoHeight = BM.bmHeight;  //   Logo.bmp
        m_bIsLogoBmp = TRUE;  //    Logo.bmp
      } else {  // g_hLogoBitmap == FALSE
        wstring wsText = L"Logo:    :\n" + wstring(m_wsLogoBmp);
        MessageBox(NULL, wsText.c_str(), L"", MB_OK);
      }  // if(g_hLogoBitmap)
    } else {  // m_wsLogoBmp == NULL
      MessageBox(NULL, L"Logo:     : \"Logo.bmp\"!\n", L"", MB_OK);
    }  // if(!m_wsLogoBmp)
  }  // if(!g_hLogoBitmap)
}  // void CAbout::DoCreate()

//====================================================================================================
// CAbout::DoPaint() -      
//====================================================================================================
void CAbout::DoPaint(HWND hWnd) {
  static HBRUSH hBrush = CreateSolidBrush(RGB(222, 222, 222));  //  

  PAINTSTRUCT PS = {0};
  HDC hAboutBitmapDC = NULL;
  HDC hLogoBitmapDC = NULL;

  //  RECT Rect = PS.rcPaint;         
  //        WM_SIZE, WM_HSCROLL, WM_VSCROLL
  //  WM_MOVE (   ,   )
  // ,      ,       
  RECT R = {0};
	GetClientRect(hWnd, &R);

  //    
  int nWidth = R.right - R.left;
  int nHeight = R.bottom - R.top;

  HDC hDC = BeginPaint(hWnd, &PS);
    //----------------------------------------------------------------------------------------------------
    //      
    //----------------------------------------------------------------------------------------------------

    //    hDC  g_hAboutBitmap
    hAboutBitmapDC = CreateCompatibleDC(hDC);

    if(m_bIsAboutBmp) {  //    About.bmp
      //  m_hAboutBitmapDC   g_hAboutBitmap
      SelectObject(hAboutBitmapDC, g_hAboutBitmap);

      //  bmp-,    ( )
      TransparentBlt(hDC, 0, 0, nWidth, nHeight, hAboutBitmapDC, 0, 0, m_nAboutWidth, m_nAboutHeight, 0);
    } else {  // m_bIsAboutBmp == FALSE
      //       
      FillRect(hDC, &R, hBrush);  //    ,     
    }  // if(m_bIsAboutBmp)

    //----------------------------------------------------------------------------------------------------
    //        
    //----------------------------------------------------------------------------------------------------

    if(m_bIsLogoBmp) {
      //    hDC  g_hLogoBitmap
      hLogoBitmapDC = CreateCompatibleDC(hDC);

      //  m_hLogoBitmapDC   g_hLogoBitmap
      SelectObject(hLogoBitmapDC, g_hLogoBitmap);

      //  bmp-  (   )
      TransparentBlt(hDC, 0, 0, m_nLogoWidth, m_nLogoHeight, hLogoBitmapDC, 0, 0, m_nLogoWidth, m_nLogoHeight, RGB(255,255,255));
      //BitBlt(hDC, 0, 0, m_nLogoWidth, m_nLogoHeight, hLogoBitmapDC, 0, 0, SRCCOPY);
    }  // if(m_bIsLogoBmp)

    //----------------------------------------------------------------------------------------------------
    //       
    //----------------------------------------------------------------------------------------------------

    //R.left += m_LogoWidth;
    WriteCenteredText(hDC, R);
    
    //----------------------------------------------------------------------------------------------------
    //   
    //----------------------------------------------------------------------------------------------------

    if(hLogoBitmapDC) DeleteDC(hLogoBitmapDC);
    if(hAboutBitmapDC) DeleteDC(hAboutBitmapDC);
	EndPaint(hWnd, &PS);
}  // CAbout::DoPaint()

//====================================================================================================
// CAbout::MDIPluginWndProc() - MDI Plug window message processing functions
//====================================================================================================
LRESULT CALLBACK CAbout::MDIPluginWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  //  -
  //static ofstream *pofsMainLog = m_struAppVars.pofsMainLog;
  //*pofsMainLog << "Plugin: uMsg = 0x" << hex << uMsg;
  //*pofsMainLog << "; wParam = 0x" << hex << wParam;
  //*pofsMainLog << "; lParam = 0x" << hex << lParam;
  //*pofsMainLog << endl;

  switch(uMsg) {
    case WM_CREATE: {
      //   WM_CREATE
      DoCreate(hWnd);
      break;
    }  // case WM_CREATE
    case WM_SETFOCUS:
      m_hAbout = hWnd;  //  ,       !
      return DefMDIChildProc(hWnd, uMsg, wParam, lParam);
    case WM_PAINT:
      DoPaint(hWnd);  //      
      break;
    case WM_SETCURSOR:
      //    ,   !    ,   !
      break;
	  case WM_SIZE:
	  case WM_MOVE:
      //         
      GetPluginWindowPos(hWnd);
      break;
	  case WM_ERASEBKGND:
      //   ,   !
      break;
    case WM_DESTROY:
      //      ini-
      m_pIMain->WriteIniFile(m_wsPlugIniFile, m_wsaComments, m_wsaFileVars, g_eMax);
      --m_nWin;  //     
      m_hAbout = GetTopWindow(m_struAppVars.hMDIClient);  //     MDIClient'a
      break;
    default:
      return DefMDIChildProc(hWnd, uMsg, wParam, lParam);
  }  // switch(uMsg)

  return 0;
}  // CAbout::MDIPluginWndProc()

#if IS_DLL
  //====================================================================================================
  // GetPluginInterface() -   ,     
  //====================================================================================================
  extern "C" DLL_API CPluginInterface *GetPluginInterface() {
    //     CAbout
    static PIPLUGIN m_pPluginInterface = new CAbout;
	
    return m_pPluginInterface;
  }  // GetPluginInterface()
#endif

//====================================================================================================
//====================================================================================================
