//====================================================================================================
// About.h -   
//====================================================================================================

#pragma once

#include "Plugin.h"  //        
#include "Common.h"  //      

//====================================================================================================
//    m_wsAboutBmp    
//====================================================================================================
typedef map<HWND, int> HWNDKMAP;

//====================================================================================================
// class CAbout -       
//====================================================================================================
class CAbout : public CPluginInterface {
  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
	public:
    //   
    virtual void InitParams(APPMEMVARS &struAppVars, CCommonInterface *pIIni) override;

    //   MDI  
    virtual BOOL RegisterMDIChild() override;

    //   MDI  
    virtual BOOL CreateMDIChildWnd() override;

    //      
    virtual BOOL IsRegistration() override;

    //      
    virtual HWND GetHChildWnd() override;

    //         
    virtual wstring &GetMenuCommand() override;

  //----------------------------------------------------------------------------------------------------
  //   
  //----------------------------------------------------------------------------------------------------
  private:
    //       MDI 
    static LRESULT CALLBACK MDIPluginWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    //   WM_CREATE
		static void DoCreate(HWND hWnd);  //      

    //   WM_PAINT
		static void DoPaint(HWND hWnd);  //      

    //       
    static void WriteCenteredText(HDC hDC, RECT &R);

    //       
    static void GetPluginWindowPos(HWND hWnd);

  //----------------------------------------------------------------------------------------------------
  // 
  //----------------------------------------------------------------------------------------------------

  private:
    //        ()  
    static wstring m_wsaComments[];

    //   ,  ,     ()  
    static wstring m_wsaFileVars[];

    //    (   About.cpp)
    static LPCWSTR m_wsPlugClassName;  //    
    static LPCWSTR m_wsPlugIniFile;  //  ini- 
    static LPCWSTR m_wsPlugIcon;  //   (   )
    static LPCWSTR m_wsAboutBmp;  //   bmp-   
    static LPCWSTR m_wsLogoBmp;  //   bmp-   
    static LPCWSTR m_wFontName;  //     
    static const int m_nFontHeight;  //          
    static const COLORREF m_nTextColor;  //     

    //   
    static APPMEMVARS m_struAppVars;  //  
    static CCommonInterface *m_pIMain;  //       

    //    m_wsAboutBmp
    static int m_nWinWidth;  //  m_wsAboutBmp
    static int m_nWinHeight;  //  m_wsAboutBmp

    //  
    static BOOL m_bIsRegistration;  //    m_wsAboutBmp
    static HWND m_hAbout;  //    m_wsAboutBmp 
    static int m_nWin;  //     (,   )

    //  
    static int m_nAboutWidth;  //   About.bmp
    static int m_nAboutHeight;  //   About.bmp
    static BOOL m_bIsAboutBmp;  //    About.bmp

    // 
    static int m_nLogoWidth;  //   Logo.bmp
    static int m_nLogoHeight;  //   Logo.bmp
    static BOOL m_bIsLogoBmp;  //    Logo.bmp

    //  
    static HFONT m_hFont;  //  
};  // class CAbout

//====================================================================================================
//    CAbout
//====================================================================================================
typedef CAbout *PAbout;  //   PIPLUGIN

#if IS_DLL
  //====================================================================================================
  // GetPluginInterface() -   ,     
  //====================================================================================================
  extern "C" DLL_API CPluginInterface *GetPluginInterface();
#endif

//====================================================================================================
//====================================================================================================
