//====================================================================================================
// App.cpp
//====================================================================================================

#include "StdAfx.h"
#include "Common.h"  //      
#include "DllLoader.h"  //  
#include "App.h"


//====================================================================================================
//   (    )
//====================================================================================================

//  
LPCWSTR CApp::m_wsMainClassName = L"MainWindow";  //     
//LPCWSTR CApp::m_wsMainLogFile = L"App\\Main.log";  //   -
LPCWSTR CApp::m_wsMainLogFile = L"";  // ,    -!
LPCWSTR CApp::m_wsMainIniFile = L"App\\Main.ini";  //   ini-
LPCWSTR CApp::m_wsMainIcon = L"App\\Main.ico";  //   ( ,  exe-,  )
HACCEL CApp::m_hAccelTable = NULL;  //   
//LPCWSTR CApp::m_wsMenuName = L"MAINMENU";  //   (  )
//LPCWSTR CApp::m_wsAccelTable = L"MAINACCS";  //    (  )

//  
LPCWSTR CApp::m_wsPlugPathMask = L"Plugins\\*.dll";  //    

//====================================================================================================
//       ()  
//====================================================================================================
enum {
  g_eWinTitle = 0,  //    
  g_eWinWidth1000,  //    (    )
  g_eWinHeight1000,  //    (    )
  //g_eWinLeft1000, //     (    )
  g_eWinTop1000, //     (    )
	eCommand,  //        
  g_eMax  //  ()     
};  // enum

//====================================================================================================
//   (    )
//====================================================================================================

//       ()  
wstring CApp::m_wsaComments[g_eMax + 1] = {
  L";    :",  // g_eWinTitle
  L";    (    ):",  // g_eWidth1000
  L";    (    ):",  // g_eHeight1000
  //L";     (    ):",  // g_eLeft1000
  L";     (    ):",  // g_eTop1000
  L";        :",  // eCommand
  L""  // g_eMax -  ()    
};  // CApp CNewWin::m_wsaComments[g_eMax + 1]

//   ,  ,    ()  
wstring CApp::m_wsaFileVars[g_eMax + 1] = {
  L" ,  ,  - !",  // g_eWinTitle
  L"600",  // g_eWidth1000
  L"850",  // g_eHeight1000
  //L"0",  // g_eLeft1000
  L"60",  // g_eTop1000
  L"&0-/&9-\tAlt+F4",  // eCommand
  L""  // g_eMax -     
};  // wstring CApp::m_wsaFileVars[g_eMax + 1]

//====================================================================================================
//   
//====================================================================================================

//  
APPMEMVARS CApp::m_struAppVars = {0};  //   (  )
//WSAFILEVARS CApp::m_wsaFileVars;  //    (  ini-)

//    
SERVICEFUNC CApp::ServiceFunctions[] = {
  AppExit,
  AppExit,  //     !
  AppExit  //     !
};

//       ()
const int CApp::m_nMaxServiceCmd = sizeof(ServiceFunctions) / sizeof(SERVICEFUNC);

//    /    
MENUPATHMAP CApp::MenuPathMap;

//    ()   Common.dll
PICOMMON CApp::m_pICommon = NULL;  //      Common.dll

//    
CDllLoaderInterface *CApp::m_pDllLoader = NULL;

////    
//PIPLUGIN CApp::m_pNewWinInterface = NULL;  //     NewWin.dll
//PIPLUGIN CApp::m_pAboutInterface = NULL;  //     About.dll

//    
PIPLUGINVEC CApp::m_Plugins;  //     (dll)


//====================================================================================================
// CApp::InitAppVars() -          
//====================================================================================================
void CApp::InitAppVars(APPMEMVARS &struAppVars) {
  //----------------------------------------------------------------------------------------------------
  //     /  
  //----------------------------------------------------------------------------------------------------
  #if IS_DLL  //  
    //    dll ( )
    m_pICommon = GetCommonInterface();  // Common.dll
    m_pDllLoader = GetDllLoaderInterface();  // Common.dll

    //    ( )  
    m_pDllLoader->LoadAllDll(m_wsPlugPathMask);

    //     ()   
    m_Plugins = m_pDllLoader->GetAllPluginInterfaces();
  #else  //   ( )
    //m_pICommon = new CCommon;  //      Common.dll
    m_pICommon = new CCommon;
    m_pDllLoader = new CDllLoader;

    static PIPLUGIN pNewWinInterface = new CNewWin;  //     NewWin.dll
    static PIPLUGIN  pAboutInterface = new CAbout;  //     About.dll

    m_Plugins.push_back(pNewWinInterface);
    m_Plugins.push_back(pAboutInterface);
  #endif  // #if IS_DLL

  //    

  //  
  struAppVars.pofsAppLog = new ofstream(m_wsMainLogFile);  //  -

  //   

  //     
  RECT Rect = {0};
  BOOL bResult = SystemParametersInfo(SPI_GETWORKAREA, 0, &Rect, 0);

  //    
  int nWorkWidth = Rect.right - Rect.left;
  int nWorkHeight = Rect.bottom - Rect.top;

  //    
  if(!nWorkWidth || !nWorkHeight) {
    MessageBox(NULL, L"   !", L"", MB_OK);
    //    !
  } else {  //     
    struAppVars.nWorkWidth = nWorkWidth;
    struAppVars.nWorkHeight = nWorkHeight;
  } // if(!nWorkWidth || !nWorkHeight)

  //    
  m_struAppVars = struAppVars;  //   (  )

  //     

  //      
  m_pICommon->MakeFolders(m_wsMainIniFile);

  //     ini-   wsaFileVars
  m_pICommon->ReadIniFile(m_wsMainIniFile, m_wsaFileVars, g_eMax + 1);
}  // CApp::InitAppVars()

//====================================================================================================
// CApp::RegisterMainWindow()
//====================================================================================================
BOOL CApp::RegisterMainWindow() {  // const HINSTANCE hInstance
  HINSTANCE hInstance = m_struAppVars.hInstance;

  // Use 'LoadImage' to load wnd class icon and cursor as it supersedes the obsolete functions 'LoadIcon'
  // and 'LoadCursor', although these functions will still work. Because the icon and cursor are loaded
  // from system resources ie they are shared, it is not necessary to free the image resources with either 
  // 'DestroyIcon' or 'DestroyCursor'.
  HICON hIcon = (HICON) LoadImage(hInstance, m_wsMainIcon, IMAGE_ICON, 0, 0, LR_LOADFROMFILE);
  HCURSOR hCursor = (HCURSOR) LoadImage(hInstance, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_SHARED);

  WNDCLASSEX WCE = {0};

  WCE.cbSize = sizeof(WNDCLASSEX); 
  //WCX.style = CS_HREDRAW | CS_VREDRAW; 
  WCE.lpfnWndProc = &CApp::MainWndProc;  //  
  //WCX.cbWndExtra = sizeof(HWND); 
  WCE.hInstance = hInstance;
  WCE.hIcon = hIcon;
  WCE.hCursor = hCursor; 
  WCE.lpszClassName = m_wsMainClassName;
  WCE.hIconSm = hIcon;
  //WCE.hbrBackground = (HBRUSH) (COLOR_BACKGROUND + 1); 
  //WCE.lpszMenuName = _wsMenuName;

  //   
  if(!RegisterClassEx(&WCE)) {
    MessageBox(NULL, L"APP: RegisterMainWindow() is wrong!", L"", MB_OK);
    return FALSE;
  }  // if(!RegisterClassEx(&wcx))

  return TRUE;
}  // CApp::RegisterMainWindow()

//====================================================================================================
// CApp::CreateAppMenu() -     ini-
//====================================================================================================
HMENU CApp::CreateAppMenu(wstring &wsMenuElem, int nIndex, HMENU hPrevMenu) {
  BOOL bRes = FALSE;
  wstring wsFullSubMenu = L"";  //   
  wstring wsSubMenu = L"";  //  
  wstring wsText = L"";  //  
  int nNum = 0;

  //      
  HMENU hMainMenu = NULL;
  if(hPrevMenu) hMainMenu = hPrevMenu;
  else hMainMenu = CreateMenu();

  HMENU hAppMenu = hMainMenu;  //    hMainMenu
  HMENU hSubMenu = CreatePopupMenu();
	DWORD dwMenuStyle = MF_POPUP | MF_STRING | MF_BYPOSITION | MF_ENABLED;
  //DWORD dwSubMenuStyle = MF_STRING;

  //          
  int nSplit = (int) wsMenuElem.find('/');

  do {
    if(wsMenuElem.size() < 4) {
      wsText = L"APP:    :\n" + wsMenuElem;
      MessageBox(NULL, wsText.c_str(), L"", MB_OK);
      return NULL;
    }  // if(wsLine.size() < 4)

    // ,    ,  ,     36- .     !

    //    '&',   '-',     36- ""  : 0 - 9 / A(a) - Z(z)
    if(wsMenuElem[0] == '&' && wsMenuElem[2] == '-') {
      nNum = wsMenuElem[1];  // .. 36- ""

      //   36- ""  : 0 - 9 / A(a) - Z(z)
      if(nNum > 47 && nNum < 58) {
        nNum -= 48;
      } else if(nNum > 64 && nNum < 91) {
        nNum -= 55;
      } else if(nNum > 96 && nNum < 123) {
        nNum -= 87;
      } else {
        //     
        nNum = -1;
      }  // if(nNum > 47 && nNum < 58)
    } else {  //  36- ""
        //     
      nNum = -1;
    }  // if(wsMenuElem[0] != '&' && wsMenuPath[2] != '-')

    if(nSplit >= 0) {
      //      !

      wsSubMenu = wsMenuElem.substr(0, nSplit);  //  
      wsMenuElem = wsMenuElem.substr(nSplit + 1);  //    

      // ,       
      if(MenuPathMap.find(wsSubMenu) == MenuPathMap.end()) {
        //      !      .
        
        // 
        //   ,      !
        //       .
        if(nNum < 0) bRes = AppendMenu(hMainMenu, dwMenuStyle, (UINT_PTR) hSubMenu, wsSubMenu.c_str());
        else bRes = InsertMenu(hMainMenu, nNum, dwMenuStyle, (UINT_PTR) hSubMenu, wsSubMenu.c_str());
      
        if(!bRes) {
          wsText = L"APP:     :\n" + wsSubMenu;
          MessageBox(NULL, wsText.c_str(), L"", MB_OK);
          return NULL;
        }  // if(!bRes)

        //// 
        //wsFullSubMenu += L"/" + wsSubMenu;  //   
        //MenuPathMap[wsFullSubMenu] = hSubMenu;  //   

        //hMainMenu = hSubMenu;
        //hSubMenu = CreatePopupMenu();
      } else {  // if(MenuPathMap.find(wsSubMenu) != MenuPathMap.end())
        //     !        ,  
        //     (    !),    .

        //        
        nSplit = (int) wsMenuElem.find('/');

        if(nSplit < 0) {
          //       

          //     
          hSubMenu = MenuPathMap[wsSubMenu];

          //    
          //   ,     !
          //       .
          if(nNum < 0) bRes = AppendMenu(hSubMenu, dwMenuStyle, nIndex, wsMenuElem.c_str());
          else bRes = InsertMenu(hSubMenu, nNum, dwMenuStyle, nIndex, wsMenuElem.c_str());
      
          if(!bRes) {
            wsText = L"APP:     :\n" + wsMenuElem;
            MessageBox(NULL, wsText.c_str(), L"", MB_OK);
            return NULL;
          }  // if(!InsertMenu(hMainMenu, nNum, dwMenuStyle, WM_USER, wsMenuPath.c_str()))
      
          break;
        }  // if(nSplit < 0)
      }  // if(MenuPathMap.find(wsSubLine) == MenuPathMap.end())
    } else {  // nSplit == -1
      //      , ..,   !
      //      (    !)
      //       .
      if(nNum < 0) bRes = AppendMenu(hMainMenu, dwMenuStyle, nIndex, wsMenuElem.c_str());
      else bRes = InsertMenu(hMainMenu, nNum, dwMenuStyle, nIndex, wsMenuElem.c_str());
      
      if(!bRes) {
        wsText = L"APP:     :\n" + wsMenuElem;
        MessageBox(NULL, wsText.c_str(), L"", MB_OK);
        return NULL;
      }  // if(!InsertMenu(hMainMenu, nNum, dwMenuStyle, WM_USER, wsMenuPath.c_str()))
      
      break;
    }  // if(nSplit >= 0)

    // 
    wsFullSubMenu += ((wsFullSubMenu.empty()) ? L"" : L"/") + wsSubMenu;  //   
    MenuPathMap[wsFullSubMenu] = hSubMenu;  //   

    hMainMenu = hSubMenu;
    hSubMenu = CreatePopupMenu();

    //        
    nSplit = (int) wsMenuElem.find('/');
  } while(true);

  return hAppMenu;
}  // CApp::CreateAppMenu()

//====================================================================================================
// CApp::CreateMainWindow()
//====================================================================================================
BOOL CApp::CreateMainWindow() {
  //      (  )    ( : Alt+F4)
  wstring wsMenuPath = m_wsaFileVars[eCommand];  //        
  HMENU hMainMenu = CreateAppMenu(wsMenuPath);  //     ini-
  PIPLUGIN pPlugInterface = NULL;

  size_t nPlugSize = m_Plugins.size();
  ACCEL *aAccels = new ACCEL[nPlugSize + 1];  //   
  wstring wsMenuCmd = L"";
  BYTE btFlag = FVIRTKEY | FNOINVERT;
  size_t nPos = 0;
  wstring wsCmd = L"";
  wstring wsKey = L"";
  size_t j = 0;

  //   
  for(size_t i = 0; i < nPlugSize; ++i) {
    //   
    pPlugInterface = m_Plugins.at(i);
    
    //         
    wsMenuPath = pPlugInterface->GetMenuCommand();
    
    //     '\t'
    nPos = wsMenuPath.rfind('\t');
    
    if(nPos > 0) {
      wsMenuCmd = wsMenuPath.substr(nPos + 1);  //         
      nPos = wsMenuCmd.rfind('+');
      
      if(nPos > 0) {
        //  

        wsCmd = wsMenuCmd.substr(0, nPos);  //           
        aAccels[j].fVirt = btFlag;

        if(wsCmd == L"Ctrl" || wsCmd == L"ctrl" || wsCmd == L"CTRL") aAccels[j].fVirt |= FCONTROL;
        else if(wsCmd == L"Shift" || wsCmd == L"shift" || wsCmd == L"SHIFT") aAccels[j].fVirt |= FSHIFT;
        else if(wsCmd == L"Alt" || wsCmd == L"alt" || wsCmd == L"ALT") aAccels[j].fVirt |= FALT;

        wsKey = wsMenuCmd.substr(nPos + 1);  //   
        aAccels[j].key = wsKey[0];
        aAccels[j].cmd = PLUGINS_BASE + j;

        ++j;
      }  // if(nPos > 0)
    }  // if(nPos > 0)

    hMainMenu = CreateAppMenu(wsMenuPath, PLUGINS_BASE + i, hMainMenu);
  }  // for(size_t i = 0; i < nPlugSize; ++i)

  //    Esc
  aAccels[j].fVirt = btFlag;
  aAccels[j].cmd = WM_CLOSE;  //   ,   
  aAccels[j].key = VK_ESCAPE;

  //   
  m_hAccelTable = CreateAcceleratorTable(aAccels, j + 1);

  //           (    )
  int nMainWinWidth = m_pICommon->CalcProportion(m_struAppVars.nWorkWidth, stoi(m_wsaFileVars[g_eWinWidth1000]), 1000);  //  
  int nMainWinHeight = m_pICommon->CalcProportion(m_struAppVars.nWorkHeight, stoi(m_wsaFileVars[g_eWinHeight1000]), 1000);  //  
  int nMainWinLeft = (m_struAppVars.nWorkWidth - nMainWinWidth) / 2;  //  
  int nMainWinTop = m_pICommon->CalcProportion(m_struAppVars.nWorkHeight, stoi(m_wsaFileVars[g_eWinTop1000]), 1000);  //  

  HWND hMainWnd = CreateWindowEx(
    WS_EX_STATICEDGE, // Extended styles
    m_wsMainClassName,
    m_wsaFileVars[g_eWinTitle].c_str(),
    WS_OVERLAPPEDWINDOW,  // | WS_VISIBLE,
    nMainWinLeft,  // Left
    nMainWinTop,  // Top
    nMainWinWidth,  // Width
    nMainWinHeight,  // Height
    NULL, // Parent wnd handle
    hMainMenu, // Menu handle
    m_struAppVars.hInstance,  // g_hInstance, // App instance
    NULL  // User defined info
  );

  if(!hMainWnd) {
    MessageBox(hMainWnd, L"APP: hMainWnd == NULL!", L"", MB_OK);
    return FALSE;
  }  // if(!hMainWnd)

  ShowWindow(m_struAppVars.hMDIClient, SW_SHOW);
  ShowWindow(hMainWnd, SW_SHOW);

  CApp::m_struAppVars.hAppWnd = hMainWnd;
  CApp::m_struAppVars.hAppMenu = hMainMenu;

  return TRUE;
}  // CreateMainWindow()

//====================================================================================================
// CApp::MainMessageLoop()
//====================================================================================================
int CApp::MainMessageLoop() {
  MSG Msg = {0};

	//   
  while(GetMessage(&Msg, NULL, 0, 0) > 0) {
    // MDI specific keyboard msgs and all other keyboard msgs
    if(!TranslateMDISysAccel(m_struAppVars.hMDIClient, &Msg) && !TranslateAccelerator(m_struAppVars.hAppWnd, m_hAccelTable, &Msg)) {
      TranslateMessage(&Msg);
      DispatchMessage(&Msg);
    }  // if(!TranslateMDISysAccel(g_hMDIClient, &Msg) && !TranslateAccelerator(hMainWnd, hAccelTable, &Msg))
  }  // while(GetMessage(&Msg, NULL, 0, 0) > 0)

  return (int) Msg.wParam;
}  // CApp::MainMessageLoop()

////====================================================================================================
//// CApp::CalcProportion() -   a*b/c    ,     
////====================================================================================================
//long CApp::CalcProportion(long a, long b, long c) {
//  if(!c) {
//    MessageBox(NULL, L"CApp::CalcProportion() :   !", L"", MB_OK);
//    return 0;
//  }  // if(!c)
//
//  //    
//  return (2*a*b + c) / (2*c);
//}  // CApp::CalcProportion()

//====================================================================================================
// CApp::GetAppWindowPos() -         
//====================================================================================================
void CApp::GetAppWindowPos(HWND hWnd) {
  RECT Rect = {0};

  //    
  GetWindowRect(hWnd, &Rect);
  m_struAppVars.nAppX = Rect.left;  //     
  m_struAppVars.nAppY = Rect.top;  //     

  //    
  m_struAppVars.nAppWidth = Rect.right - Rect.left;  //   
  m_struAppVars.nAppHeight = Rect.bottom - Rect.top;  //   

  //    ( )   (    )
  int nMainWinWidth1000 = m_pICommon->CalcProportion(1000, m_struAppVars.nAppWidth, m_struAppVars.nWorkWidth);  //  
  int nMainWinHeight1000 = m_pICommon->CalcProportion(1000, m_struAppVars.nAppHeight, m_struAppVars.nWorkHeight);  //  
  int nMainWinTop1000 = m_pICommon->CalcProportion(1000, m_struAppVars.nAppY, m_struAppVars.nWorkHeight);  //  

  //     g_wsaFileVars
  m_wsaFileVars[g_eWinWidth1000] = WOSS(nMainWinWidth1000);
  m_wsaFileVars[g_eWinHeight1000] = WOSS(nMainWinHeight1000);
  m_wsaFileVars[g_eWinTop1000] = WOSS(nMainWinTop1000);
}  // CApp::GetAppWindowPos()

//====================================================================================================
// void CApp::AppExit() -     ini-    
//====================================================================================================
void CApp::AppExit(APPMEMVARS &struAppVars, WSAFILEVARS wsaFileVars) {
  //     ini-
  m_pICommon->WriteIniFile(m_wsMainIniFile, m_wsaComments, m_wsaFileVars, g_eMax);

  //   
  PostQuitMessage(0);
}  // void CApp::AppExit()

//====================================================================================================
// CApp::MainWndProc() - Main window message processing functions
//====================================================================================================
LRESULT CALLBACK CApp::MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  CLIENTCREATESTRUCT MDIClientCreateStruct = {0};  // Structure to be used for MDI client area
  static HWND hMDIClient = NULL;
  int nId = LOWORD(wParam);
  //int nServiceId = 0;  //    
  //int nPluginId = 0;  //     ()

  //static ofstream *pofsAppLog = m_struAppVars.pofsAppLog;  //  -
  //*pofsAppLog << "App: uMsg = 0x" << hex << uMsg;
  //*pofsAppLog << "; wParam = 0x" << hex << wParam;
  //*pofsAppLog << "; lParam = 0x" << hex << lParam;
  //*pofsAppLog << endl;

	switch(uMsg) {
	  case WM_CREATE:
		  // On creation of main frame, create the MDI client area
		  //MDIClientCreateStruct.hWindowMenu	= NULL;
		  MDIClientCreateStruct.idFirstChild = PLUGINS_BASE;  // 50000;  // IDM_FIRSTCHILD;
		
		  hMDIClient = CreateWindowEx(
        WS_EX_STATICEDGE,
        L"MDIClient",  //  
			  NULL,
			  WS_CHILD | WS_CLIPCHILDREN,  // | WS_VISIBLE,
			  0,
			  0, 
			  0,
			  0,
			  hWnd,
			  NULL,
			  m_struAppVars.hInstance,
			  (void *) &MDIClientCreateStruct
      );

      if(!hMDIClient) MessageBox(hWnd, L"App: hMDIClient == NULL!", L"", MB_OK);
      m_struAppVars.hMDIClient = hMDIClient;

      return 0;
    case WM_COMMAND:
      //       nId,   
      if(SERVICES_BASE <= nId && nId < SERVICES_BASE + m_nMaxServiceCmd) {
        ServiceFunctions[nId - SERVICES_BASE](m_struAppVars, m_wsaFileVars);
        return 0;
      }  // if(0 <= nServiceId && nServiceId < m_nMaxServiceCmd)

      //     ()   nId,   
      if(PLUGINS_BASE <= nId && nId < PLUGINS_BASE + (int) m_Plugins.size()) {
        PIPLUGIN pPlugInterface = m_Plugins.at(nId - PLUGINS_BASE);

        if(!pPlugInterface) {
          MessageBox(NULL, L"App: pPlugInterface == NULL!", L"", MB_OK);
          return 0;
        }  // if(!pDllInterface)

        //     ,  
        if(!pPlugInterface->IsRegistration()) {
          pPlugInterface->InitParams(m_struAppVars, m_pICommon);
          pPlugInterface->RegisterMDIChild();
        }  // if(!pDllInterface && !pDllInterface->IsRegistration())
        
        //       ,  
        pPlugInterface->CreateMDIChildWnd();
        
        return 0;
      }  // if(PLUGINS_BASE <= nId && nId < g_nMaxPlugin)

      switch(nId) {
        //case SERVICES_BASE + 0:
        //case SERVICES_BASE + 1:
        //case SERVICES_BASE + 2: {
        //  //    !
        //  wstring wsText = L"SERVICES_BASE + " + WOSS(nId - SERVICES_BASE);
        //  MessageBox(NULL, L"APP:     !", wsText.c_str(), MB_OK);
        //  return 0;
        //}  // case SERVICES_BASE + i
        case WM_CLOSE: {
          HWND hPlugin = GetFocus();
          //HWND hParent = GetParent(hPlugin);
          if(GetParent(hPlugin) == hMDIClient) {
            SendMessage(hPlugin, WM_CLOSE, 0, 0);
            return 0;
          }  // if(GetParent(hPlugin) == hMDIClient)
    		  break;
        }  // case WM_CLOSE
        default:
          break;
      }  // switch(nId)

      break;
	  case WM_SIZE:
	  case WM_MOVE:
      //         
      GetAppWindowPos(hWnd);
      break;
	  case WM_ERASEBKGND:
		  return 0;
	  case WM_DESTROY:
      //     ini-    
      AppExit(m_struAppVars, m_wsaFileVars);
		  return 0;
    default:
      break;
	}  // switch(uMsg)

	return DefFrameProc(hWnd, hMDIClient, uMsg, wParam, lParam);
}  // CApp::MainWndProc()

#if IS_DLL
 //====================================================================================================
 // GetAppInterface() -   ,     
 //====================================================================================================
 extern "C" DLL_API CAppInterface *GetAppInterface() {
   //    
   static CAppInterface *m_pAppInterface = new CApp;  //     CApp
	
   return m_pAppInterface;
 }  // GetAppInterface()
#endif

//====================================================================================================
//====================================================================================================
