//====================================================================================================
// App.h -   
//====================================================================================================

#pragma once

#include "Common.h"  //  ,    
#include "DllLoader.h"  //  

#if IS_DLL
  //   (   ,   run time, )
#else 
  //   (     )
  #include "NewWin.h"
  #include "About.h"
#endif

//    (     )
typedef void (*SERVICEFUNC)(APPMEMVARS &struAppVars, WSAFILEVARS wsaFileVars);

//         
typedef map<wstring, HMENU> MENUPATHMAP;

//====================================================================================================
// class CAppInterface -         
//====================================================================================================
class CAppInterface {
  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
	public:
    //          
    virtual void InitAppVars(APPMEMVARS &struAppVars) = 0;

    //    
    virtual BOOL RegisterMainWindow() = 0;

    //    
    virtual BOOL CreateMainWindow() = 0;

    //    
    virtual int MainMessageLoop() = 0;

  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
  private:
    //   
    virtual HMENU CreateAppMenu(wstring &wsMenuElem, int nIndex=SERVICES_BASE, HMENU hPrevMenu=NULL) = 0;
};  // class CAppInterface

//====================================================================================================
// class CApp -     
//====================================================================================================
class CApp : public CAppInterface {
  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
	public:
    //          
    virtual void InitAppVars(APPMEMVARS &struAppVars) override;

    //    
    virtual BOOL RegisterMainWindow() override;

    //    
    virtual BOOL CreateMainWindow() override;

    //    
    virtual int MainMessageLoop() override;

  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
  private:
    //   
    virtual HMENU CreateAppMenu(wstring &wsMenuElem, int nIndex=SERVICES_BASE, HMENU hPrevMenu=NULL) override;

  //----------------------------------------------------------------------------------------------------
  //   
  //----------------------------------------------------------------------------------------------------
  private:
    //         
    static void GetAppWindowPos(HWND hWnd);

    //     ini-    
    static void AppExit(APPMEMVARS &struAppVars, WSAFILEVARS wsaFileVars);

    //     
    //virtual LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) override;
    static LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

  //----------------------------------------------------------------------------------------------------
  // 
  //----------------------------------------------------------------------------------------------------
  private:
    //        ()  
    static wstring m_wsaComments[];  // g_eMax + 1

    //   ,  ,     ()  
    static wstring m_wsaFileVars[];  // g_eMax + 1

    //  
    static APPMEMVARS m_struAppVars;  //   ()   (  )
    //static WSAFILEVARS m_wsaFileVars;  //    (   ini-)
    static LPCWSTR m_wsMainClassName;  //     
    static LPCWSTR m_wsMainLogFile;  //   -
    static LPCWSTR m_wsMainIniFile;  //   ini-
    static LPCWSTR m_wsMainIcon;  //    ( ,  ,  )  
    static HACCEL m_hAccelTable;  //   

    //  
    static SERVICEFUNC ServiceFunctions[];  //   
    static const int m_nMaxServiceCmd;  //       ()

    // 
    static MENUPATHMAP MenuPathMap;  //    /    

    //    () 
    static PICOMMON m_pICommon;  //    ()   Common.dll
    
    //    
    static CDllLoaderInterface *m_pDllLoader;
    
    //    
    static PIPLUGINVEC m_Plugins;  //      (dll)

    //  
    static LPCWSTR m_wsPlugPathMask;  //    
};  // class CApp

#if IS_DLL
  //====================================================================================================
  // GetAppInterface() -   ,    cpp-
  //====================================================================================================
  extern "C" DLL_API CAppInterface *GetAppInterface();
#endif

//====================================================================================================
//====================================================================================================
