//====================================================================================================
// DllLoader.h
//====================================================================================================

#pragma once

#include "Plugin.h"  //        

//----------------------------------------------------------------------------------------------------
// Typedefs -  ,     dll
//----------------------------------------------------------------------------------------------------
//typedef CCommonInterface *(*PGetCommonInterface)();  //   (   )
typedef CPluginInterface *(*PGetPluginInterface)();  //  


//====================================================================================================
// class CDllLoaderInterface -    
//====================================================================================================
class CDllLoaderInterface {
  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
  public:
    //   dll   wsDllPathMask
	  virtual void LoadAllDll(LPCWSTR pwsDllPathMask) = 0;

    //     dll
	  virtual void UnloadAllDll() = 0;

    //         
    //virtual void GetAllPluginInterfaces(PIPLUGINVEC *pvPIPlugin) = 0;
    virtual PIPLUGINVEC &GetAllPluginInterfaces() = 0;

  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
  private:
    //  dll    
	  virtual void LoadDll(LPCWSTR pwsDllPath) = 0;

    //  dll    
	  virtual void UnloadDll(HMODULE hDll, wstring &wsDllPath) = 0;

    //  , : CPluginInterface
    virtual PIPLUGIN GetPluginInterface(HMODULE hDll, wstring &wsDllPath) = 0;
};  // class CDllLoaderInterface

//====================================================================================================
// class CDllLoader -   
//====================================================================================================
class CDllLoader : public CDllLoaderInterface {
  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
  public:
    //   dll   wsDllPathMask
	  virtual void LoadAllDll(LPCWSTR pwsDllPathMask) override;

    //     dll
	  virtual void UnloadAllDll() override;

    //         
    virtual PIPLUGINVEC &GetAllPluginInterfaces() override;

  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
  private:
    //  dll    
	  virtual void LoadDll(LPCWSTR pwsDllPath) override;

    //  dll    
	  virtual void UnloadDll(HMODULE hDll, wstring &wsDllPath) override;

    //  , : CPluginInterface
    virtual PIPLUGIN GetPluginInterface(HMODULE hDll, wstring &wsDllPath) override;

  //----------------------------------------------------------------------------------------------------
  // 
  //----------------------------------------------------------------------------------------------------
  private:
    // 
    static WSVECTOR m_WSPlugins;  //     
    static HMODULEVEC m_HModules;  //    
    static PIPLUGINVEC m_PIPlugins;  //      
};  // class CDllLoader

//====================================================================================================
// GetDllLoaderInterface() -   ,    cpp-
//====================================================================================================
extern "C" DLL_API CDllLoaderInterface *GetDllLoaderInterface();

//====================================================================================================
//====================================================================================================
