//====================================================================================================
// Ini.cpp -   CIni  CCommon
//====================================================================================================

#include "StdAfx.h"
#include "Common.h"


//====================================================================================================
// CCommon::ReadIniFile() -     ini-   wsaFileVars
//====================================================================================================
void CCommon::ReadIniFile(LPCWSTR pwsIniFile, WSAFILEVARS wsaFileVars, int nFileVarsCount) {
  // ,   wsaFileVars       

  //  ini-file
	wifstream wifsIni = wifstream(pwsIniFile, ios_base::out | ios_base::binary);	
  wifsIni.imbue(locale(locale::empty(), new codecvt_utf8<wchar_t>));

  //    ,   (   )
  if(!wifsIni) return;

  wstring wsLine = L"";  //  
  int i = 0;  //   
  int j = -1;  //     

  while(getline(wifsIni, wsLine)) {
    if(!wsLine.empty() && wsLine[0] == ';') {
      //     
      i = 0;
      ++j;
    } else {
       //     
      if(!i++) wsaFileVars[j] = wsLine;
      else wsaFileVars[j] += L"\n" + wsLine;
    }  // if(wsLine[0] == ';')

    // ""  !
    if(j >= nFileVarsCount) break;
  }  // while(getline(wifsIni, wsLine))

  wifsIni.close();
}  // CCommon::ReadIniFile()

//====================================================================================================
// CCommon::WriteIniFile() -     ini-
//====================================================================================================
void CCommon::WriteIniFile(LPCWSTR pwsIniFile, WSAFILEVARS wsaComments, WSAFILEVARS wsaFileVars, int nFileVarsCount) {
  //  ini-file
	wofstream wofsIni = wofstream(pwsIniFile, ios_base::out | ios_base::binary);
	wofsIni.imbue(locale(locale::empty(), new codecvt_utf8<wchar_t>));

  //    ,    
  if(!wofsIni) {
    wstring wsText = L"Ini:    ini-:\n" + wstring(pwsIniFile);
    MessageBox(NULL, wsText.c_str(), L"", MB_OK);
    return;
  }  // if(wifsIni)

  wstring wsText = L"";  //  
  wstring wsVar = L"";  //    
  
  //     ini-
  for(int i = 0; i < (int) nFileVarsCount; ++i) {
    wsText = wsaComments[i];
    wsVar = wsaFileVars[i];

    wofsIni << wsText << endl;
    wofsIni << wsVar << endl;
  }  // for(int i = 0; i < nFileVarsCount; ++i)
  
  wofsIni.close();
}  // CCommon::WriteAppIniFile()

////====================================================================================================
//// CCommon::MakeFolders() -      
////====================================================================================================
//void CCommon::MakeFolders(LPCWSTR wsFilePath) {
//  if(wsFilePath == NULL) return;
//  if(wsFilePath[0] == 0) return;
//
//  //      
//  if(wsFilePath[1] == ':') return;
//
//  wstring wsCurFolder = L"";
//  wstring wsCurPath = wsFilePath;
//
//  //         
//  int nSplit = (int) wsCurPath.find('/');
//  if(nSplit < 0) nSplit = (int) wsCurPath.find('\\');
//
//  WCHAR wcCurDir[_MAX_PATH] = {0};
//  GetCurrentDirectory(_MAX_PATH, wcCurDir);
//
//  while(nSplit >= 0) {
//    if(nSplit) {
//      wsCurFolder = wsCurPath.substr(0, nSplit);  //  
//
//      if(wsCurFolder.size() > 1 && wsCurFolder[0] == '.' && wsCurFolder[1] != '.') {
//        //    
//        SetCurrentDirectory(L".");
//      }  // if(wsCurFolder.size() > 1 && wsCurFolder[0] == '.' && wsCurFolder[1] != '.')
//
//      //    ( ) 
//      if(wsCurFolder.size() > 1 && wsCurFolder[0] == '.' && wsCurFolder[1] == '.') {
//        wsCurFolder = wsCurFolder.substr(2);
//        nSplit += 2;
//      }  // if(wsCurFolder.size() > 1 && wsCurFolder[0] == '.' && wsCurFolder[1] == '.')
//
//      //     CurFolder
//      if(wsCurFolder.size() > 0) {
//        if(CreateDirectory(wsCurFolder.c_str(), NULL)) {
//          SetCurrentDirectory(wsCurFolder.c_str());
//        } else {
//          if(!SetCurrentDirectory(wsCurFolder.c_str())) {
//            SetCurrentDirectory(wcCurDir);
//            return;  //   !
//          }  // if(!SetCurrentDirectory(wsCurFolder.c_str())
//        }  // if(CreateDirectory(wsCurFolder.c_str(), NULL))
//      }  // if(wsCurFolder.size() > 0)
//    }  // if(nSplit)
//
//    //         
//    wsCurPath = wsCurPath.substr(nSplit + 1);  //   
//    nSplit = (int) wsCurPath.find('/');
//    if(nSplit < 0) nSplit = (int) wsCurPath.find('\\');
//  }  // while(nSplit >= 0)
//
//  SetCurrentDirectory(wcCurDir);
//}  // CCommon::MakeFolders()
//
////====================================================================================================
//// CCommon::CalcProportion() -   a*b/c    ,     
////====================================================================================================
//long CCommon::CalcProportion(long a, long b, long c) {
//  if(!c) {
//    MessageBox(NULL, L"CCommon::CalcProportion() :   !", L"", MB_OK);
//    return a;
//  }  // if(!c)
//
//  // Multiplies two 32-bit values and then divides the 64-bit result by a third 32-bit value.
//  // The final result is rounded to the nearest integer.
//  return MulDiv(a, b, c);
//
//  ////    
//  //return (2*a*b + c) / (2*c);
//}  // CCommon::CalcProportion()
//
////====================================================================================================
//// GetCommonInterface() -   ,     
////====================================================================================================
//extern "C" DLL_API CCommonInterface *GetCommonInterface() {
//  //    
//  static CCommonInterface *m_pCommonInterface = new CCommon;  //     CCommon
//	
//  return m_pCommonInterface;
//}  // GetCommonInterface()

//====================================================================================================
//====================================================================================================
