//====================================================================================================
// NewWin.cpp -   
//====================================================================================================

#include "StdAfx.h"
#include "Common.h"  //      
#include "NewWin.h"

//====================================================================================================
//  
//====================================================================================================

HBITMAP g_hBitmap = NULL;  //  

//====================================================================================================
//       ()   
//====================================================================================================
enum {
  g_eWinTitle = 0,  //  
  g_eWinWidth1000,  //    (     )
  g_eWinHeight1000,  //    (     )
  //g_eWinLeft1000, //     (     )
  //g_eWinTop1000, //     (     )
  g_eCommand,  //        
  g_eWinTextMax, //      
  g_eWinText01,  //  No. 01   
  g_eWinText02,  //  No. 02   
  g_eWinText03,  //  No. 03   
  g_eWinText04,  //  No. 04   
  g_eWinText05,  //  No. 05   
  g_eWinText06,  //  No. 06   
  g_eWinText07,  //  No. 07   
  g_eWinText08,  //  No. 08   
  g_eWinText09,  //  No. 09   
  g_eWinText10,  //  No. 10   
  g_eWinText11,  //  No. 11   
  g_eWinText12,  //  No. 12   
  g_eMax  //  ()    
};  // enum

//====================================================================================================
//     ,   CNewWin
//====================================================================================================

//       ()  
wstring CNewWin::m_wsaComments[g_eMax + 1] = {
  L";   :",  // g_eWinTitle
  L";    (     ):",  // g_eWinWidth1000
  L";    (     ):",  // g_eWinHeight1000
  //L";     (     ):",  // g_eWinLeft1000
  //L";     (     ):",  // g_eWinTop1000
  L";        :",  // g_eCommand
  L";      :",  // g_eWinTextMax
  L";  No. 01   :",  // g_eWinText01
  L";  No. 02   :",  // g_eWinText02
  L";  No. 03   :",  // g_eWinText03
  L";  No. 04   :",  // g_eWinText04
  L";  No. 05   :",  // g_eWinText05
  L";  No. 06   :",  // g_eWinText06
  L";  No. 07   :",  // g_eWinText07
  L";  No. 08   :",  // g_eWinText08
  L";  No. 09   :",  // g_eWinText09
  L";  No. 10   :",  // g_eWinText10
  L";  No. 11   :",  // g_eWinText11
  L";  No. 12   :",  // g_eWinText12
  L""  // g_eMax -  ()    
};  // wstring CNewWin::m_wsaComments[g_eMax + 1]

//   ,  ,    ()  
wstring CNewWin::m_wsaFileVars[g_eMax + 1] = {
  L"         ?",  // g_eWinTitle
  L"850",  // g_eWinWidth1000
  L"550",  // g_eWinHeight1000
  //L"0",  // g_eWinLeft1000
  //L"25",  // g_eWinTop1000
  L"&0-/&0- \tCtrl+N",  // g_eCommand
  L"12",  // g_eWinTextMax
  L"    , \n    .\n ,  ,  .\n , !\n  \n       .\n    ,\n    .\n   ,  ,\n     .",  // g_eWinText01
  L" .\n  .\n      .\n ,  ,\n,  \n   .",  // g_eWinText02
  L"  \n ,  .\n, , .\n \n ,\n  \n  !",  // g_eWinText03
  L"  .\n  \n    \n ,  \n    .\n  , ,\n!",  // g_eWinText04
  L"  \n  ,\n \n   \n\n  \n  !",  // g_eWinText05
  L" ,  ,\n    .\n---\n   .\n     !",  // g_eWinText06
  L"   ,\n   \n  -,\n  .\n,  ,\n,  .",  // g_eWinText07
  L" ,   :\n  -!\n  :\n   ?!\n - \n !",  // g_eWinText08
  L", .\n  \n    ?\n     \n  \n  !",  // g_eWinText09
  L" ,   ,\n  .\n .\n .\n ,   .\n      ,\n  ,   .",  // g_eWinText10
  L"!\n,    \n   - ?\n  - ,   ?\n  -   \n?",  // g_eWinText11
  L" ,  ,\n   .\n  ,  ,\n  \n!\n       ,\n       !",  // g_eWinText12
  L""  // g_eMax -     
};  // wstring CNewWin::m_wsaFileVars[g_eMax + 1]

//====================================================================================================
//    CNewWin
//====================================================================================================

LPCWSTR CNewWin::m_wsPlugClassName = L"NewWinWindow";  //     
LPCWSTR CNewWin::m_wsPlugIniFile = L"Plugins\\Res\\NewWin.ini";  //  ini- 
LPCWSTR CNewWin::m_wsPlugIcon = L"Plugins\\Res\\NewWin.ico";  //   (   )
LPCWSTR CNewWin::m_wsPlugBmp = L"Plugins\\Res\\NewWin.bmp";  //   bmp-    
LPCWSTR CNewWin::m_wFontName = L"Arbat-Bold";  //      
const int CNewWin::m_nFontHeight = 36;  //      
const COLORREF CNewWin::m_nTextColor = RGB(0, 0, 128);  //     - -

//     
const COLORREF CNewWin::m_nColorLevel = 36;  //  ,  0  255 ( ,      )
const int CNewWin::m_nDelta = 100;  //      ,   
const int CNewWin::m_nKMax = 10;  //    : 1+2+3+4+5+6+7+...+m_nKMax = m_nKMax*(m_nKMax + 1)/2;
const int CNewWin::m_nWinMax = m_nKMax*(m_nKMax + 1)/2;  //     
HWNDKMAP CNewWin::m_hWinKMap;  //        
HWND CNewWin::m_hWindows[m_nWinMax] = {NULL};  //     
HBRUSH CNewWin::m_hBrushes[m_nWinMax] = {NULL};  //  ,  ,   
int CNewWin::m_nWinTextMax = 0;  //     (12,  : g_eWinText01 - g_eWinText12)
int CNewWin::m_nX[m_nWinMax] = {0};  //    ,   
int CNewWin::m_nY[m_nWinMax] = {0};  //    ,   
int CNewWin::m_nWin = 0;  //    

//   
APPMEMVARS CNewWin::m_struAppVars = {0};  //  
CCommonInterface *CNewWin::m_pIMain = NULL;  //       

//    
int CNewWin::m_nWinWidth = 0;  //  
int CNewWin::m_nWinHeight = 0;  //  

//  
BOOL CNewWin::m_bIsRegistration = FALSE;  //    
HWND CNewWin::m_hNewWin = NULL;  //     

//  
int CNewWin::m_nBmpWidth = 0;  //   bmp-
int CNewWin::m_nBmpHeight = 0;  //   bmp-

//  
HFONT CNewWin::m_hFont;  //  

//====================================================================================================
// CNewWin::CreateRandomBrushes() -   ,  
//====================================================================================================
void CNewWin::CreateRandomBrushes() {
  //            rand()
  srand(static_cast<unsigned int>(time(0)));

  //   
  COLORREF nColor = 0;
  int nR = 0;  // 
  int nG = 0;  // 
  int nB = 0;  // 
  int nP = m_nColorLevel;  //  

  for(int k = 0; k < m_nWinMax; ++k) {
    //   
    nR = 255 - rand() % nP;
    nG = 255 - rand() % nP;
    nB = 255 - rand() % nP;

    //  ,  ,    
    //m_nColors[k] = RGB(nR, nG, nB);
    nColor = RGB(nR, nG, nB);

    //  ,  ,   
    //m_hBrushes[k] = CreateSolidBrush(m_nColors[k]);
    m_hBrushes[k] = CreateSolidBrush(nColor);
  }  // for(int k = 0; k < m_nWinMax; ++k)
}  // CNewWin::CreateRandomBrush()

//====================================================================================================
// CNewWin::InitOffsets() -      
//====================================================================================================
void CNewWin::InitOffsets() {
  int k = 0;

  //       
  for(int i = 0; i < m_nKMax; ++i) {
    for(int j = 0; j <= i; ++j) {
      m_nX[k] = j;  //    
      m_nY[k] = i - j;  //    
      ++k;
    }  // for(int j = 0; j <= i; ++j)
  }  // for(int i = 0; i < m_nKMax; ++i)
}  // CNewWin::InitOffsets()

//====================================================================================================
// CNewWin::InitParams() -   
//====================================================================================================
void CNewWin::InitParams(APPMEMVARS &struAppVars, CCommonInterface *pIIni) {
  //         
  m_pIMain = pIIni;

  //     ini-    m_wsaFileVars
  m_pIMain->ReadIniFile(m_wsPlugIniFile, m_wsaFileVars, g_eMax + 1);

  //    
  m_struAppVars = struAppVars;  //   (  )

  //       (12,  : g_eWinText01 - g_eWinText12)
  m_nWinTextMax = stoi(m_wsaFileVars[g_eWinTextMax]);

  //     
  m_hFont = CreateFont(
    m_nFontHeight, 0, 0, 0, 500,
    FALSE, FALSE, FALSE,
    DEFAULT_CHARSET,
    OUT_DEFAULT_PRECIS,
    CLIP_DEFAULT_PRECIS, 
		PROOF_QUALITY,
    VARIABLE_PITCH,
    m_wFontName
  );

  //   ,  
  CreateRandomBrushes();

  //      
  InitOffsets();

  //      
  m_pIMain->MakeFolders(m_wsPlugIniFile);
}  // CNewWin::InitParams()

//====================================================================================================
// CNewWin::RegisterMDIChild() -   MDI  
//====================================================================================================
BOOL CNewWin::RegisterMDIChild() {
  HINSTANCE hInstance = m_struAppVars.hInstance;
  HICON hIcon = (HICON) LoadImage(hInstance, m_wsPlugIcon, IMAGE_ICON, 0, 0, LR_LOADFROMFILE);
  HCURSOR hCursor = (HCURSOR) LoadImage(hInstance, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_SHARED);

  WNDCLASSEX WCX = {0};
  
  WCX.cbSize = sizeof(WNDCLASSEX);
  WCX.style = CS_HREDRAW | CS_VREDRAW; 
  WCX.lpfnWndProc = MDIPluginWndProc; 
  WCX.cbWndExtra = sizeof(HWND); 
  WCX.hInstance = hInstance; 
  WCX.hIcon = hIcon; 
  WCX.hCursor = hCursor; 
  WCX.lpszClassName = m_wsPlugClassName;
  WCX.hIconSm = hIcon;
  WCX.hbrBackground = NULL;  // CreateSolidBrush(RGB(222, 164, 222)); 
  WCX.lpszMenuName = NULL;

  //       Windows
  if(!RegisterClassEx(&WCX)) {
    MessageBox(NULL, L"NewWin: RegisterMDIPlug() is wrong!", L"", MB_OK);
    return FALSE;
  }  // if(!RegisterClassEx(&WCX))

  m_bIsRegistration = TRUE;  //    

  return TRUE;
}  // CNewWin::RegisterMDIChild()

//====================================================================================================
// CNewWin::CreateMDIChildWnd() -   MDI  
//====================================================================================================
BOOL CNewWin::CreateMDIChildWnd() {
  //f(k >= m_nWinMax) return 0;

  static RECT R = {0};
  GetClientRect(m_struAppVars.hMDIClient, &R);

  //           (    )
  m_nWinWidth = m_pIMain->CalcProportion(stoi(m_wsaFileVars[g_eWinWidth1000]), R.right, 1000);  //  
  m_nWinHeight = m_pIMain->CalcProportion(stoi(m_wsaFileVars[g_eWinHeight1000]), R.bottom, 1000);  //  

  static int nX = 0;
  static int nY = 0;

  if(m_nWin == 0) {  //    
    nX = (R.right - m_nWinWidth) / 2;  //  
    nY = (R.bottom - m_nWinHeight)/2;  //  
  } else {
    nY = m_nX[m_nWin - 1]*m_nDelta;
    nX = m_nY[m_nWin - 1]*m_nDelta;
  }  // if(m_nWin == 0)

  m_hNewWin = CreateWindowEx(
    WS_EX_MDICHILD,
    m_wsPlugClassName,
    m_wsaFileVars[g_eWinTitle].c_str(),  // Windows Title
    WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,  // | WS_CHILD
    nX,  // Left
    nY,  // Top
    m_nWinWidth,  // Width
    m_nWinHeight,  // Height
    m_struAppVars.hMDIClient,  // Parent
    NULL,  // Menu
    m_struAppVars.hInstance,  // Instance
    NULL  // User defined info
  );

  if(!m_hNewWin) {
    //MessageBox(NULL, L"NewWin: m_hNewWin == NULL!", L"", MB_OK);
    return FALSE;
  }  // if(!m_hNewWin)

  m_hWinKMap[m_hNewWin] = m_nWin;  //        
  m_hWindows[m_nWin] = m_hNewWin;  //     
  ++m_nWin;

  return TRUE;
}  // CNewWin::CreateMDIChildWnd()

//====================================================================================================
// CNewWin::IsRegistration() -      
//====================================================================================================
BOOL CNewWin::IsRegistration() {
  return m_bIsRegistration;
}  // CNewWin::GetHPlugWnd()

//====================================================================================================
// CNewWin::GetHChildWnd() -      
//====================================================================================================
HWND CNewWin::GetHChildWnd() {
  return m_hNewWin;
}  // CNewWin::GetHChildWnd()

//====================================================================================================
// CNewWin::GetMenuCommand() -         
//====================================================================================================
wstring &CNewWin::GetMenuCommand() {
  static wstring wsCommand = m_wsaFileVars[g_eCommand];
  return wsCommand;
}  // CNewWin::GetMenuCommand()

//====================================================================================================
// CNewWin::WriteCenteredText() -       
//====================================================================================================
void CNewWin::WriteCenteredText(HDC hDC, int k, RECT &R) {
  //     ,  
  if(!m_nWinTextMax) return;

  //     
  SetBkMode(hDC, TRANSPARENT);
        
  //     
  SetTextColor(hDC, m_nTextColor);
        
  HFONT hOldFont = (HFONT) SelectObject(hDC, m_hFont);
  wstring wsText = L"";

  wsText = m_wsaFileVars[g_eWinText01 + k % m_nWinTextMax];  //      
        
  //        
  int n = 1;  //      
  for(int i = 0; i < (int) wsText.size(); ++i) {
    if(wsText[i] == '\n') ++n;
  }  // for(int i = 0; i < wsText.size(); ++i)

  if(n*m_nFontHeight < R.bottom) R.top = (R.bottom - n*m_nFontHeight)/2;  //  

  DrawText(hDC, (LPWSTR) wsText.c_str(), (int) wsText.size(), &R, DT_CENTER);
        
  SelectObject(hDC, hOldFont);
}  // CNewWin::WriteCenteredText()

//====================================================================================================
// CNewWin::GetPluginWindowPos() -       
//====================================================================================================
void CNewWin::GetPluginWindowPos(HWND hWnd) {
  RECT Rect = {0};  //  

  //    
  GetWindowRect(hWnd, &Rect);
  int nPlugWidth = Rect.right - Rect.left;  //   k
  int nPlugHeight = Rect.bottom - Rect.top;  //   k

  //      
  GetWindowRect(m_struAppVars.hMDIClient, &Rect);
  int nParentWidth = Rect.right - Rect.left;  //     
  int nParentHeight = Rect.bottom - Rect.top;  //     

  //    ( )   (    )
  int nWinWidth1000 = MulDiv(1000, nPlugWidth, nParentWidth);  //  
  int nWinHeight1000 = MulDiv(1000, nPlugHeight, nParentHeight);  //  

  //     g_wsaFileVars
  m_wsaFileVars[g_eWinWidth1000] = WOSS(nWinWidth1000);
  m_wsaFileVars[g_eWinHeight1000] = WOSS(nWinHeight1000);
}  // CNewWin::GetPluginWindowPos()

//====================================================================================================
// CNewWin::DoPaint() -      
//====================================================================================================
void CNewWin::DoPaint(HWND hWnd) {
  PAINTSTRUCT PS = {0};
  HDC hDC = NULL;
  
  int k = m_hWinKMap[hWnd];  //   ,     hWnd
  HBRUSH hBrush = m_hBrushes[k];
  //COLORREF nColor = m_nColors[k];
  RECT R = {0};

  //  RECT Rect = PS.rcPaint;         
  //        WM_SIZE, WM_HSCROLL, WM_VSCROLL
  //  WM_MOVE (   ,   )
  // ,      ,       
	GetClientRect(hWnd, &R);

  //    
  int nWidth = R.right - R.left;
  int nHeight = R.bottom - R.top;

  hDC = BeginPaint(hWnd, &PS);
    //----------------------------------------------------------------------------------------------------
    //       
    //----------------------------------------------------------------------------------------------------

    FillRect(hDC, &R, hBrush);  //    ,     

    //----------------------------------------------------------------------------------------------------
    //      
    //----------------------------------------------------------------------------------------------------

    //    hDC  ,  ,   
    HDC hMemoryDC = CreateCompatibleDC(hDC);
    
    //    
    BITMAPINFO BMI = {{sizeof(BMI.bmiHeader), nWidth, -nHeight, 1, 32, BI_RGB, nWidth*nHeight, 0, 0, NULL, NULL}, NULL};  //    
    BYTE *pBytes = NULL;  //    ,   CreateDIBSection(),  ,   
    HBITMAP hMemoryBitmap = CreateDIBSection(NULL, &BMI, DIB_RGB_COLORS, (void **) &pBytes, NULL, NULL);
    
    //    hMemoryDC
    (HBITMAP) SelectObject(hMemoryDC, hMemoryBitmap);

    //     ,  ,  
	  PatBlt(hMemoryDC, 0, 0, nWidth, nHeight, WHITENESS);

    //    ,  ,   (   )
    SelectObject(hMemoryDC, hBrush);
	  
    //     ,      m_nBmpWidth,   
    Ellipse(hMemoryDC, m_nBmpWidth, 0, nWidth, nHeight);
    
    int nVal = 0;

    //----------------------------------------------------------------------------------------------------
    // ,  ,    ,      
    //----------------------------------------------------------------------------------------------------

    for(int j = 0; j < nHeight; ++j) {
      for(int i = 0; i < nWidth; ++i, pBytes += 4) {
        //      
        nVal = (int) (i + j - 1.85*sqrt(1.*i*j));

	      pBytes[0] *= nVal; pBytes[0] %= 256;
	      pBytes[1] *= nVal; pBytes[1] %= 256;
	      pBytes[2] *= nVal; pBytes[2] %= 256;
	      pBytes[3] = 0;  //    !
      }  // for(int i = 0; i < nWidth; ++i, pBytes += 4)
    }  // for(int j = 0; j < nHeight; ++j)

    // ,   , ,   
    BitBlt(hDC, 0, 0, nWidth, nHeight, hMemoryDC, 0, 0, SRCPAINT);  //   
    //BitBlt(hDC, 0, 0, nWidth, nHeight, hMemoryDC, 0, 0, MERGEPAINT);  //       

    //----------------------------------------------------------------------------------------------------
    //    
    //----------------------------------------------------------------------------------------------------

    //    hDC  g_hBitmap
    HDC hFileBitmapDC = CreateCompatibleDC(hDC);

    //  m_hFileBitmapDC   g_hBitmap
    SelectObject(hFileBitmapDC, g_hBitmap);

    //  bmp-
    TransparentBlt(hDC, 0, 0, m_nBmpWidth, m_nBmpHeight, hFileBitmapDC, 0, 0, m_nBmpWidth, m_nBmpHeight, RGB(255,255,255));

    //----------------------------------------------------------------------------------------------------
    //       
    //----------------------------------------------------------------------------------------------------

    R.left += m_nBmpWidth;
    WriteCenteredText(hDC, k, R);
    
    //----------------------------------------------------------------------------------------------------
    //   
    //----------------------------------------------------------------------------------------------------

    DeleteObject(hMemoryBitmap);
    DeleteDC(hMemoryDC);
    DeleteDC(hFileBitmapDC);
	EndPaint(hWnd, &PS);
}  // CNewWin::DoPaint()

//====================================================================================================
// CNewWin::MDIPluginWndProc() - MDI Plug window message processing functions
//====================================================================================================
LRESULT CALLBACK CNewWin::MDIPluginWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  //  -
  //static ofstream *pofsMainLog = m_struAppVars.pofsMainLog;
  //*pofsMainLog << "Plugin: uMsg = 0x" << hex << uMsg;
  //*pofsMainLog << "; wParam = 0x" << hex << wParam;
  //*pofsMainLog << "; lParam = 0x" << hex << lParam;
  //*pofsMainLog << endl;

  switch(uMsg) {
    case WM_NCCREATE: {
      if(m_nWin >= m_nWinMax) {
        wstring wsText = L"     : " + WOSS(m_nWin);
        MessageBox(NULL, wsText.c_str(), L"NewWin: ", MB_OK);
        break;
      }  // if(m_nWin >= m_nWinMax)

      return DefMDIChildProc(hWnd, uMsg, wParam, lParam);
    }  // case WM_NCCREATE
    case WM_CREATE: {
      if(!m_wsPlugBmp) break;

      if(!g_hBitmap) {
        //   
        g_hBitmap = (HBITMAP) LoadImage(m_struAppVars.hInstance, m_wsPlugBmp, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
      
        //  
        if(!g_hBitmap) {
          wstring wsText = L"NewWin:    :\n" + wstring(m_wsPlugBmp);
          MessageBox(NULL, wsText.c_str(), L"", MB_OK);
          return 0;
        }  // if(!g_hBitmap)

        BITMAP BM = {0};

        //   
        GetObject(g_hBitmap, sizeof(BITMAP), (LPVOID) &BM);

        m_nBmpWidth = BM.bmWidth;  //   bmp-
        m_nBmpHeight = BM.bmHeight;  //   bmp-
      }  // if(!m_hBitmap)

      //         ,        ( WM_PAINT)
      break;
    }  // case WM_CREATE
    case WM_SETFOCUS:
      m_hNewWin = hWnd;  //  ,       !
      return DefMDIChildProc(hWnd, uMsg, wParam, lParam);
      break;
    case WM_PAINT:
      DoPaint(hWnd);  //      
      break;
    case WM_SETCURSOR:
      //    ,   !    ,   !
      break;
	  case WM_SIZE:
	  case WM_MOVE:
      //         
      GetPluginWindowPos(hWnd);
      break;
	  case WM_ERASEBKGND:
      //   ,   !
      break;
    case WM_DESTROY:
      //      ini-
      m_pIMain->WriteIniFile(m_wsPlugIniFile, m_wsaComments, m_wsaFileVars, g_eMax);
      //if(m_nKMax > 1) m_hNewWin = NULL;  //      !

      --m_nWin;  //     

      //   ,  ,   
      if(!m_nWin) CreateRandomBrushes();

      m_hNewWin = GetTopWindow(m_struAppVars.hMDIClient);  //     MDIClient'a

      break;
    default:
      return DefMDIChildProc(hWnd, uMsg, wParam, lParam);
  }  // switch(uMsg)

  return 0;
}  // CNewWin::MDIPluginWndProc()

#if IS_DLL
  //====================================================================================================
  // GetPluginInterface() -   ,     
  //====================================================================================================
  extern "C" DLL_API CPluginInterface *GetPluginInterface() {
    //     CNewWin
    static PIPLUGIN m_pPluginInterface = new CNewWin;
	
    return m_pPluginInterface;
  }  // GetPluginInterface()
#endif

//====================================================================================================
//====================================================================================================
