//====================================================================================================
// NewWin.h -   
//====================================================================================================

#pragma once

#include "Plugin.h"  //        
#include "Common.h"  //      

//====================================================================================================
//        
//====================================================================================================
typedef map<HWND, int> HWNDKMAP;

//====================================================================================================
// class CNewWin -       
//====================================================================================================
class CNewWin : public CPluginInterface {
  //----------------------------------------------------------------------------------------------------
  // 
  //----------------------------------------------------------------------------------------------------

	public:
    //   
    virtual void InitParams(APPMEMVARS &struAppVars, CCommonInterface *pIIni) override;

    //   MDI  
    virtual BOOL RegisterMDIChild() override;

    //   MDI  
    virtual BOOL CreateMDIChildWnd() override;

    //      
    virtual BOOL IsRegistration() override;

    //      
    virtual HWND GetHChildWnd() override;

    //         
    virtual wstring &GetMenuCommand() override;

  private:
    //       MDI  
    static LRESULT CALLBACK MDIPluginWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    //   WM_PAINT
	  static void DoPaint(HWND hWnd);  //      

    //      
    static void WriteCenteredText(HDC hDC, int k, RECT &R);

    //       
    static void GetPluginWindowPos(HWND hWnd);

  //---     
  private:
    //   ,  
    static void CreateRandomBrushes();

    //      
    static void InitOffsets();

  //----------------------------------------------------------------------------------------------------
  // 
  //----------------------------------------------------------------------------------------------------

  private:
    //        ()  
    static wstring m_wsaComments[];

    //   ,  ,     ()  
    static wstring m_wsaFileVars[];

    //    (   NewWin.cpp)
    static LPCWSTR m_wsPlugClassName;  //     
    static LPCWSTR m_wsPlugIniFile;  //  ini- 
    static LPCWSTR m_wsPlugIcon;  //   (   )
    static LPCWSTR m_wsPlugBmp;  //   bmp-    
    static LPCWSTR m_wFontName;  //      
    static const int m_nFontHeight;  //          
    static const COLORREF m_nTextColor;  //    

    //     
    static const COLORREF m_nColorLevel;  //  ,  0  255 ( ,      )
    static const int m_nDelta;  //      ,   
    static const int m_nKMax;  //    : 1+2+3+4+5+6+7+...+m_nKMax = m_nKMax*(m_nKMax + 1)/2;
    static const int m_nWinMax;  // = m_nKMax*(m_nKMax + 1)/2;  //     
    static HWNDKMAP m_hWinKMap;  //        
    static HWND m_hWindows[];  //     
    static HBRUSH m_hBrushes[];  //  ,  ,   
    static int m_nWinTextMax;  //       (12,  : eWinText01 - eWinText12)
    static int m_nX[];  //    ,   
    static int m_nY[];  //    ,   
    static int m_nWin;  //    

    //   
    static APPMEMVARS m_struAppVars;  //  
    static CCommonInterface *m_pIMain;  //       

    //    
    static int m_nWinWidth;  //  
    static int m_nWinHeight;  //  

    //  
    static BOOL m_bIsRegistration;  //    
    static HWND m_hNewWin;  //     

    //  
    static int m_nBmpWidth;  //   bmp-
    static int m_nBmpHeight;  //   bmp-

    //  
    static HFONT m_hFont;  //  
};  // class CNewWin

//====================================================================================================
//    CNewWin
//====================================================================================================
typedef CNewWin *PNewWin;  //   PIPLUGIN

#if IS_DLL
  //====================================================================================================
  // GetPluginInterface() -   ,     
  //====================================================================================================
  extern "C" DLL_API CPluginInterface *GetPluginInterface();
#endif

//====================================================================================================
//====================================================================================================
